/**
 * Pyx4me framework
 * Copyright (C) 2005-2007 Michael Lifshits
 * Copyright (C) 2005-2007 Vlad Skarzhevskyy
 *
 * @version $Id: InstrumentedTestCaseHelper.java 1 2007-03-09 04:03:48Z vlads $
 */
package cldcunit.runner;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestMethod;

public class InstrumentedTestCaseHelper extends BaseTestCaseHelper {

	public InstrumentedTestCaseHelper() {
	}

	public void setTestCase(TestCase testCase) {
		super.setTestCase(testCase);
	}

	
	public TestMethod[] createAllTestMethods() {
		TestCase testCase = getTestCase();
		if (TestCaseReflectionData.class.isAssignableFrom(testCase.getClass())) {
			return ((TestCaseReflectionData)testCase).getDeclaredTestMethods();
		} else {
			//throw new Error("TestCase " + testCase + " is not instrumented");
			return null;
		}
	}

	public TestMethod createTestMethod(String name) {
		TestCase testCase = getTestCase();
		if (TestCaseReflectionData.class.isAssignableFrom(testCase.getClass())) {
			TestMethod[] methods = ((TestCaseReflectionData)testCase).getDeclaredTestMethods();
			for (int i = 0; i < methods.length; i++) {
				if (methods[i].getName().equals(name)) {
					return methods[i];
				}
			}
			return null;
		} else {
			throw new Error("TestCase " + testCase + " is not instrumented");
		}
	}

	public Test getSuite() {
		TestCase testCase = getTestCase();
		if (TestCaseReflectionData.class.isAssignableFrom(testCase.getClass())) {
			return ((TestCaseReflectionData)testCase).getSuite();
		} else {
			throw new Error("TestCase " + testCase + " is not instrumented");
		}
	}


}
